<project name="Build specific targets and properties" default="noDefault" basedir=".">

	<!-- ===================================================================== -->
	<!-- Run a given ${target} on all elements being built -->
	<!-- ===================================================================== -->
	<target name="allElements">
        <ant antfile="${genericTargets}" target="${target}">
            <property name="type" value="feature" />
            <property name="id" value="org.eclipse.mtj" />
        </ant>
        <ant antfile="${genericTargets}" target="${target}">
            <property name="type" value="feature" />
            <property name="id" value="org.eclipse.mtj.examples" />
        </ant>
        <ant antfile="${genericTargets}" target="${target}">
            <property name="type" value="feature" />
            <property name="id" value="org.eclipse.mtj.sdk" />
        </ant>
	</target>

	<!-- ===================================================================== -->
	<!-- Targets to assemble the built elements for particular configurations  -->
	<!-- These generally call the generated assemble scripts (named in -->
	<!-- ${assembleScriptName}) but may also add pre and post processing -->
	<!-- Add one target for each root element and each configuration -->
	<!-- ===================================================================== -->

	<target name="assemble.org.eclipse.mtj">
        <property name="archiveName" value="dsdp-mtj-runtime-incubation-${buildId}.zip"/>
		<ant antfile="${assembleScriptName}" />
        <antcall target="unpackUpdateJarsForPackaging" />
	</target>
    <target name="assemble.org.eclipse.mtj.examples">
        <property name="archiveName" value="dsdp-mtj-examples-incubation-${buildId}.zip"/>
        <ant antfile="${assembleScriptName}" />
        <antcall target="unpackUpdateJarsForPackaging" />
    </target>
    <target name="assemble.org.eclipse.mtj.sdk">
        <property name="archiveName" value="dsdp-mtj-SDK-incubation-${buildId}.zip"/>
        <ant antfile="${assembleScriptName}" />
        <antcall target="unpackUpdateJarsForPackaging" />
    </target>

    <target name="unpackUpdateJarsForPackaging">
        <property name="tmpsite" value="${buildDirectory}/tmpsite"/>
        <mkdir dir="${tmpsite}/new/eclipse/features" />
        <mkdir dir="${tmpsite}/new/eclipse/plugins" />
        <exec executable="unzip" dir="${buildDirectory}/${buildLabel}">
            <arg line="-q ${archiveName} -d ${tmpsite}" />
        </exec>
        <copy todir="${updateSiteDirectory}" verbose="true">
            <fileset dir="${tmpsite}/eclipse"/>
        </copy>

        <unpackUpdateJars site="${tmpsite}/eclipse" output="${tmpsite}/new/eclipse"/>
        <antcall target="packageLicenseFiles"/>
        <zip destfile="${buildDirectory}/${buildLabel}/${archiveName}"
            basedir="${tmpsite}/new"
        />
        <delete dir="${tmpsite}"/>
    </target>
	
    <target name="packageLicenseFiles">
        <copy file="${rootScriptsDirectory}/templateFiles/epl-v10.html" todir="${tmpsite}/new/eclipse" verbose="true"/>
        <copy file="${rootScriptsDirectory}/templateFiles/notice.html" todir="${tmpsite}/new/eclipse" verbose="true"/>
    </target>
	
	<!-- ===================================================================== -->
	<!-- Check out map files from correct repository -->
	<!-- Replace values for cvsRoot, package and mapVersionTag as desired. -->
	<!-- ===================================================================== -->
	<target name="checkLocal">
		<available property="mapsLocal" file="${buildDirectory}/maps" />
	</target>

	<target name="getMapFiles" depends="checkLocal" unless="mapsLocal">
		<echo message="Copy Map Files" />
		<copy todir="${buildDirectory}/maps" overwrite="true">
			<fileset dir="${mapsDirectory}" />
		</copy>
	</target>

	<target name="tagMapFiles" if="tagMaps">
	</target>

	<!-- ===================================================================== -->
	<!-- Steps to do before setup -->
	<!-- ===================================================================== -->
	<target name="preSetup">
		<mkdir dir="${buildDirectory}/${buildLabel}" />
	</target>

	<!-- ===================================================================== -->
	<!-- Steps to do after setup but before starting the build proper -->
	<!-- ===================================================================== -->
	<target name="postSetup">
	</target>

	<!-- ===================================================================== -->
	<!-- Steps to do before fetching the build elements -->
	<!-- ===================================================================== -->
	<target name="preFetch">
	</target>

	<!-- ===================================================================== -->
	<!-- Steps to do after the fetch -->
	<!-- ===================================================================== -->
	<target name="postFetch">
		<replace dir="${buildDirectory}/plugins" value="${timestamp}" token="@buildid@">
			<include name="**/about.mappings" />
		</replace>
	</target>

	<!-- ===================================================================== -->
	<!-- Steps to do before generating build scripts -->
	<!-- ===================================================================== -->
	<target name="preGenerate">
	</target>

	<!-- ===================================================================== -->
	<!-- Steps to do after generating the build scripts -->
	<!-- ===================================================================== -->
	<target name="postGenerate">
		<antcall target="clean" />
	</target>

	<!-- ===================================================================== -->
	<!-- Steps to do before assembling -->
	<!-- ===================================================================== -->
	<target name="preAssemble">
	</target>

	<!-- ===================================================================== -->
	<!-- Steps to do after assembling-->
	<!-- ===================================================================== -->
	<target name="postAssemble">

		<!--copy todir="${basedir}" file="${buildDirectory}/finalFeaturesVersions.properties" overwrite="true" />
		<property file="finalFeaturesVersions.properties" />

		<ant antfile="${rootScriptsDirectory}/buildUpdateSite.xml" target="ArchiveSite">
			<property name="featute.id" value="org.eclipse.mtj.sdk" />
			<property name="component.type" value="SDK" />
			<property name="feature.version" value="${org.eclipse.mtj.sdk}" />
			<property name="siteOutputDirectory" value="${buildDirectory}/${buildLabel}" />
		</ant>

		<echo message="dest file : ${buildDirectory}/${buildLabel}/${archiveName}" />

		<zip destfile="${buildDirectory}/${buildLabel}/${archiveName}" update="true">
			<fileset dir="${buildDirectory}/${buildLabel}" includes="site.xml" />
		</zip>
		<delete file="${buildDirectory}/${buildLabel}/site.xml" /-->
	</target>

	<!-- ===================================================================== -->
	<!-- Steps to do before running the build.xmls for the elements being built. -->
	<!-- ===================================================================== -->
	<target name="preProcess">
		<replace dir="${buildDirectory}/plugins" value="${timestamp}" token="@build@">
			<include name="**/about.mappings" />
		</replace>
	</target>

	<!-- ===================================================================== -->
	<!-- Steps to do after running the build.xmls for the elements being built. -->
	<!-- ===================================================================== -->
	<target name="postProcess">
	</target>

	<!-- ===================================================================== -->
	<!-- Steps to do after everything is built and assembled -->
	<!-- (e.g., testing, posting, emailing, ...) -->
	<!-- ===================================================================== -->
	<target name="postBuild">
		<antcall target="gatherLogs" />
	</target>

	<!-- ===================================================================== -->
	<!-- Helper targets -->
	<!-- ===================================================================== -->
	<target name="gatherLogs">
		<mkdir dir="${buildDirectory}/${buildLabel}/compilelogs" />
		<antcall target="allElements">
			<param name="target" value="gatherLogs" />
		</antcall>

		<unzip dest="${buildDirectory}/${buildLabel}/compilelogs" overwrite="true">
			<fileset dir="${buildDirectory}/features/org.eclipse.mtj.sdk">
				<include name="*.log.zip" />
			</fileset>
		</unzip>
	</target>
	<target name="clean" unless="noclean">
		<antcall target="allElements">
			<param name="target" value="cleanElement" />
		</antcall>
	</target>

	<!-- ===================================================================== -->
	<!-- Default target                                                        -->
	<!-- ===================================================================== -->
	<target name="noDefault">
		<echo message="You must specify a target when invoking this file" />
	</target>

</project>
